/* * (C) Copyright IBM Corporation 2006, 2014. */
/*
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA


 Author: IBM Corporation
 This module is part of the IBM (R) Rational (R) ClearCase (R)
 Multi-version file system (MVFS).
 For support, please visit http://www.ibm.com/software/support

*/
#ifndef MVFS_VIEWROOT_H_
#define MVFS_VIEWROOT_H_

#include "mvfs_base.h"

/* All viewroot subsystem data is now contained in this structure.  There is a
** forward declaration and a typedef for this in mvfs_systm.h since it is used
** in function prototypes that are defined (in mvfs_base.h) before this file is
** included.
**
** There are two kinds of viewroots: dynamic and automatic (also called remote
** views or rviews in a server context).  There could be more in the future, so
** the actual viewroot object (defined in mvfs.h) will be an array of
** mvfs_viewroot_data_t of size MVFS_VIEWROOT_SZ indexed by an enum
** mvfs_viewroot_type for the view type.  The mvfs_viewroot_type_t enum is
** defined in mfs_ioctl.h since it is shared with user space (e.g., mount_mvfs,
** libatriatbs).
*/
struct mvfs_viewroot_data {
    VFS_T *mfs_viewroot_vfsp;
    VNODE_T *mfs_viewroot_vp;
    VNODE_T *mfs_viewroot_specvp;
    LOCK_T mvfs_mkviewtag_lock;
};

#endif /* MVFS_VIEWROOT_H_ */
/* $Id: 1d08ee8f.3541445c.a901.4f:a2:7c:cf:e5:93 $ */
